close all;
clear all;
clc;

seq = struct('name','trellis','path','./Trellis/img/','startFrame',1,'endFrame',569,'nz',4,'ext','jpg','init_rect', [0,0,0,0]);
finalPath = './results/';
if ~exist(['../.' finalPath],'dir')
    mkdir(['../.' finalPath]);
end

tmpRes_path = './tmp/';
bSaveImage=1;
if ~exist(['../.' tmpRes_path],'dir')
    mkdir(['../.' tmpRes_path]);
end

pathAnno = '../../anno/';
seq.len = seq.endFrame - seq.startFrame + 1;
seq.s_frames = cell(seq.len,1);
nz	= strcat('%0',num2str(seq.nz),'d'); %number of zeros in the name of image
for i=1:seq.len
    image_no = seq.startFrame + (i-1);
    id = sprintf(nz,image_no);
    seq.s_frames{i} = strcat(seq.path,id,'.',seq.ext);
end
rect_anno = dlmread([pathAnno seq.name '.txt']);
seq.annoBegin = seq.startFrame;
seq.init_rect = rect_anno(1,:);

rp = [tmpRes_path seq.name '/'];
if bSaveImage && ~exist(['../.' rp],'dir')
    mkdir(['../.' rp]);
end

res = run_TGPR(seq, rp, bSaveImage);

res.len = seq.len;
res.annoBegin = seq.annoBegin;
res.startFrame = seq.startFrame;
res.anno = rect_anno;

save(['../.' finalPath seq.name '.mat'], 'res');